# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ...brands.types.brand import Brand
from ...core.datetime_utils import serialize_datetime
from ...core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ...core.unchecked_base_model import UncheckedBaseModel
from .attachment import Attachment
from .tracking_override import TrackingOverride


class MessageChannelEmailOverride(UncheckedBaseModel):
    attachments: typing.Optional[typing.List[Attachment]] = None
    bcc: typing.Optional[str] = None
    brand: typing.Optional[Brand] = None
    cc: typing.Optional[str] = None
    from_: typing.Optional[str] = pydantic_v1.Field(alias="from", default=None)
    html: typing.Optional[str] = None
    reply_to: typing.Optional[str] = None
    subject: typing.Optional[str] = None
    text: typing.Optional[str] = None
    tracking: TrackingOverride

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
