# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from ....core.unchecked_base_model import UncheckedBaseModel


class Device(UncheckedBaseModel):
    app_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Id of the application the token is used for
    """

    ad_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Id of the advertising identifier
    """

    device_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Id of the device the token is associated with
    """

    platform: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The device platform i.e. android, ios, web
    """

    manufacturer: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The device manufacturer
    """

    model: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The device model
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
